package sav.example.javaz;
import sav.z.*;
import java.io.*;
/**
 * This is example of the cycles with Base iteration.
 * The Base methods: header(), row(), size(), first(),
 * next(), last(), back() are considred.
 */
public class DBIterationDemo {
  public static void main(String arg[]) throws IOException {
    /* Initial table creation */
    String script =
      "$base 'CompanyX'~;" +
      "$readTable() <" +
      "employee; name;           department; salary \n" +
      "101;      'Adams Smith';  1;          50000 \n" +
      "102;      'Clark White';  1;          30000 \n" +
      "103;      'Jones Hunter'; 2;          60000 \n" +
      "104;      'Blake Dull';   3;          65000 \n" +
      "105;      'Sylvia Smith'; 1;          25000 \n" +
      "108;      'Albert Green'; 3;          40000 \n" +
      "109;      'Clark Ringer'; 2;          50000 \n" +
      ">;"
    ;
    Session ss = new Session();
    ss.z(script);

    ss.exploreBase("CompanyX");
    Base base = ss.base();
    /* Backward viewing the salaries and
       creation array of directories
     */
    int size = base.size("department") + 1;
    String directors[] = new String[size];
    int number = base.size("salary");
    String salary = base.last("salary");
    while (salary != null) {
      String emp[] =  base.attrArray("salary:" + salary, "employee");
      for (int i = 0; i < emp.length; ++i) {
        String dep = base.attrValue("employee:" + emp[i], "department");
        int ndep = Integer.parseInt(dep);
        if (directors[ndep] == null)
          directors[ndep] = emp[i];
      }
      if (--number <= 0)
        break;
      salary = base.back("salary", salary);
    }

    /*
     Forward iteration of the employee and
     printing changed rows
    */
   int EMP = 0;
   int DEP = 2;
    String header[] = base.header("employee");
    System.out.println();
    for (int i = 0; i < header.length; ++i) {
      System.out.print(header[i] + "; ");
    }
    System.out.print("position");
    System.out.println();
    for (String emp = base.first("employee"); emp != null; emp = base.next("employee", emp)) {
      String row[] = base.row("employee:" + emp, header);
//      String row[] = base.row("employee:" + emp, header);
//      String row[] = base.row("employee:" + emp);
      for (int i = 0; i < header.length; ++i) {
        System.out.print(row[i] + "; ");
      }
      int ndep = Integer.parseInt(row[DEP]);
      if (row[EMP].equals(directors[ndep]))
        System.out.print("director");
      System.out.println();
    }

    base.close();
  }
}
